import { EventEmitter, OnDestroy, TemplateRef } from '@angular/core';
import { BehaviorSubject, Observable, Subject } from 'rxjs';
import { OffcanvasPosition } from '../../types/position';
import { BsViewState } from '../../../../types/view-state.type';
import * as i0 from "@angular/core";
export declare class BsOffcanvasComponent implements OnDestroy {
    constructor(contentTemplate: TemplateRef<any>);
    contentTemplate: TemplateRef<any>;
    destroyed$: Subject<unknown>;
    visibility$: Observable<string>;
    disableTransition$: BehaviorSubject<boolean>;
    offcanvasClass$: BehaviorSubject<string | null>;
    width$: Observable<number | null>;
    height$: Observable<number | null>;
    hasBackdrop$: BehaviorSubject<boolean>;
    show$: Observable<boolean>;
    showBackdrop$: Observable<boolean>;
    position$: BehaviorSubject<OffcanvasPosition>;
    set position(value: OffcanvasPosition);
    get position(): OffcanvasPosition;
    size$: BehaviorSubject<number | null>;
    set size(value: number | null);
    get size(): number | null;
    state$: BehaviorSubject<BsViewState>;
    stateChange: EventEmitter<boolean>;
    set state(value: BsViewState);
    get state(): BsViewState;
    backdropClick: EventEmitter<MouseEvent>;
    onBackdropClick(ev: MouseEvent): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<BsOffcanvasComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BsOffcanvasComponent, "bs-offcanvas-holder", never, { "position": "position"; "size": "size"; "state": "state"; }, { "stateChange": "stateChange"; "backdropClick": "backdropClick"; }, never, never, false>;
}
